﻿{
    function precompTrim()
    {	

        var curComp = app.project.activeItem;
        if (!(curComp instanceof CompItem))
        {
            alert("Please select a composition.");
            return;
        }
    
        var layers = curComp.selectedLayers;
        if (layers.length == 0)
        {
            alert("Please select one or more layers.");
            return;
        }
    
        app.beginUndoGroup("Precomp and Trim Layers");
        
        var compFolder = prompt("Comp Folder Name", "Trimmed Comps");
        
        var projItems = app.project.items;
        for (var i=1; i<=projItems.length; i++)
            if (projItems[i].typeName == "Folder" && projItems[i].name == compFolder)
            {
                compFolder = projItems[i];
                break;
            }
        
        compFolder = app.project.items.addFolder(compFolder);

        var offset = parseInt(prompt("Add Handles (frames)", "0"));
        offset = offset * curComp.frameDuration;


        for (var i=0; i<layers.length; i++)
        {
            var inPoint = layers[i].inPoint-offset, outPoint = layers[i].outPoint+offset;

			//	Kevin: add the time in the comp name
			//	>>>
			//	>>>
			var roundTo = 10;
			var compName = layers[i].name + " Precomp";
			var preCompName = compName + " - " + Math.round(inPoint*roundTo)/roundTo + " s to " + Math.round(outPoint*roundTo)/roundTo + " s";
			//	<<<
			//	<<<
            
            var preCompIndices = new Array();
            preCompIndices[0] = layers[i].index;
            
            var duration = outPoint - inPoint;
            
            layers[i].startTime -= inPoint;
            layers[i].inPoint = 0;
            layers[i].outPoint = duration;
            
            var preCompItem = curComp.layers.precompose(preCompIndices, preCompName, true);
            preCompItem.duration = duration;
            preCompItem.parentFolder = compFolder;
            preCompItem.workAreaStart = 0;
            preCompItem.workAreaDuration = preCompItem.duration;
            
            var preComp = curComp.selectedLayers[0];
            preComp.startTime = inPoint;
            preComp.inPoint = inPoint+offset;
            preComp.outPoint = outPoint-offset;

			//	Kevin: rename the layer in the comp
			//	>>>
			//	>>>
			preComp.name = compName;
			//	<<<
			//	<<<
        }
    
        app.endUndoGroup();
    }

    precompTrim();
}